{Convert a confusion matrix into substitution distances.}
program ConfusionToDistances;
uses SysUtils, StrUtils;
const scaling = 100.0;
var
   FIn, FOut : TextFile;
   OrigChars : String;
   EditedChar : Char;
   NumChars : Integer;
   I, J, Misspels : Integer;
   AllSummed : Integer = 0;
   Biggest : Integer = 0;
   Distance : Double;
begin
   if ParamCount < 2 then begin
      WriteLn ('Give input and output file name as command line argument.');
      exit
   end;
   AssignFile (FIn, ParamStr (1));
   AssignFile (FOut, ParamStr (2));
   Reset (FIn); Rewrite (FOut);
   try
      while not EOF (FIn) do
         try
            Read (FIn, Misspels);
            AllSummed := AllSummed + Misspels;
            if Misspels > Biggest then Biggest := Misspels
         except on EInOutError do {nothing}
         end;
      CloseFile (FIn); Reset (FIn);
      ReadLn (FIn, OrigChars);
      NumChars := WordCount (OrigChars, StdWordDelims);
      for I := 1 to NumChars do
      begin
         Read (FIn, EditedChar);
         for J := 1 to WordCount (OrigChars, StdWordDelims) do
         begin
            Read (FIn, Misspels);
            if Misspels > 0
            then begin
               Distance := AllSummed / NumChars / Misspels / scaling;
               WriteLn (FOut, EditedChar, ' ',
                        ExtractWord (J, OrigChars, StdWordDelims), ' ',
                        Distance:0:2)
            end
         end;
         ReadLn (FIn)
      end
   finally
      CloseFile (FOut); CloseFile (FIn)
   end
end.