{Compute the string edit distance and alignment.}
program EditDistanceProg;
uses SysUtils, math;
function CharFun (b : Boolean) : Double;
begin
   if b then CharFun := 1.0 else CharFun := 0.0
end;
var
   {D[i,j] is distance between X[1..i] and Y[1..j],
    where X[1..0] is the empty string.}
   D : array of array of Double;
   X, Y : String;               {Input strings.}
   SubstCost : Double;
   {Compute all alignments via backtracking.}
   procedure Align (i, j : Integer; const AlignX, AlignY : String);
   begin
      if (i = 0) and (j = 0)
      then begin
         WriteLn ('Alignment:');
         WriteLn (AlignX); WriteLn (AlignY) end
      else if i = 0 then Align (i, j-1, '*' + AlignX, Y[j] + AlignY)
      else if j = 0 then Align (i-1, j, X[i] + AlignX, '*' + AlignY)
      else begin
         if D[i,j] = D[i-1,j] + 1
         then Align (i-1, j, X[i] + AlignX, '*' + AlignY);
         if D[i,j] = D[i,j-1] + 1
         then Align (i, j-1, '*' + AlignX, Y[j] + AlignY);
         if ((D[i,j] = D[i-1,j-1] + SubstCost) and (X[i] <> Y[j]))
            or ((D[i,j] = D[i-1,j-1]) and (X[i] = Y[j]))
         then Align (i-1, j-1, X[i] + AlignX, Y[j] + AlignY)
      end
   end;
var
   M, N : Integer;              {Length of strings.}
   i, j : Integer;              {Matrix indices.}
begin
   Write ('Give X: ');
   ReadLn (X);
   Write ('Give Y: ');
   ReadLn (Y);
   Write ('Give substitution cost (2 for Levenstein distance): ');
   ReadLn (SubstCost);
   M := Length (X);
   N := Length (Y);
   SetLength (D, M+1, N+1);
   for i := 0 to M do D[i,0] := i;
   for j := 0 to N do D[0,j] := j;
   for i := 1 to M do
      for j := 1 to N do
         D[i,j] := min (D[i-1,j] + 1, {Insertion.}
                        min (D[i,j-1] + 1, {Deletion.}
                             D[i-1,j-1] + SubstCost*CharFun (X[i] <> Y[j])));
   WriteLn ('Distance of X and Y: ', D[M,N]:0:2);
   Align (M, N, '', '')
end.